export default {

    init: function () {
        if ( ! this.Vue.http) {
            return 'vue-resource.1.x.js : Vue.http must be set.';
        }
    },
    
    interceptor: function (req, res) {
        var _this = this;

        this.Vue.http.interceptors.push(function (request, next) {
            if (req) { req.call(_this, request); }
            
            next(function (response) {
                if (res) { res.call(_this, response, request); }
            });
        });
    },

    invalidToken: function (res) {
        if (res.status === 401) {
            return true;
        }
    },

    httpData: function (res) {
        return res.data || {};
    },

    http: function (data) {
        return this.Vue.http(data);
    },

    getHeaders: function (res) {
        var i,
            data = {},
            headers = res.headers.map;

        for (i in headers) {
            data[i] = headers[i][0];
        }

        return data;
    },

    setHeaders: function (req, headers) {
        var i;

        for (i in headers) {
            req.headers.set(i, headers[i]);
        }
    }
};